//-------------------------------------------------------------------------------------------------
// TheMessageHandler.h (engine)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_TheMessageHandler_
#define _include_TheMessageHandler_


//-------------------------------------------------------------------------------------------------
// Easy-access macro
//-------------------------------------------------------------------------------------------------
#define MESSAGE (TheMessageHandler::Singleton())


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "engineCommon.h"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		TheMessageHandler
//
///////////////////////////////////////////////////////////////////////////////////////////////////
class TheMessageHandler
{
private:
	/// Static members
	static TheMessageHandler* _theMessageHandler;
	static bool _isConstructed;
	static bool _isInitialized;

	/// Private constructors
	TheMessageHandler(); // default constructor

public:
	~TheMessageHandler(); // destructor

	static TheMessageHandler* CreateSingleton();
	static TheMessageHandler* Singleton();
	static void DestroySingleton();

	void Init();
	void Shutdown();
	const bool HandleWin32Message( const HWND hWnd, const UINT uMsg, const WPARAM wParam, const LPARAM lParam );
};


#endif // _include_TheMessageHandler_
