// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#pragma once
#include "BasePipe.h"
#include "Spawner.h"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		BaseNode
//
///////////////////////////////////////////////////////////////////////////////////////////////////
struct BaseNode
{
	BaseNodeType			m_type;
	int						m_numberOfConnections;
	Vector2					m_pos;
	AABB2					m_bounds;
	int						m_gridX;
	int						m_gridY;
	BasePipe*				m_connections[ NUM_HEXDIRECTIONS ];
	Base*					m_base;
	int						m_hitPoints;
	bool					m_isConnectedToHeart;
	Spawner*				m_spawner;

	BaseNode();
	~BaseNode();

	void InitVacantNode( Base* pBase, int x, int y );
	HexDirection FindPipeAmongConnections( BasePipe* pipe );
	void UnhookPipe( BasePipe* pipe );
	void UpgradeConnectionType();
	bool IsEmpty();
	void UpdateSpawner();
};


