// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#include "pch.h"
#include "BaseCommon.h"
#include "Image.h"
#include "gameCommon.h"
#include "TheGame.h"
using namespace std;


//-------------------------------------------------------------------------------------------------
// BasePipe
//-------------------------------------------------------------------------------------------------
BasePipe::BasePipe()
{
}


//-------------------------------------------------------------------------------------------------
// ~BasePipe
//-------------------------------------------------------------------------------------------------
BasePipe::~BasePipe()
{
}


//-------------------------------------------------------------------------------------------------
// IsDying
//-------------------------------------------------------------------------------------------------
bool BasePipe::IsDying()
{
	return (m_status == PIPESTATUS_DYING_FORWARD) || (m_status == PIPESTATUS_DYING_BACKWARD);
}


//-------------------------------------------------------------------------------------------------
// CalcAnimFraction
//-------------------------------------------------------------------------------------------------
float BasePipe::CalcAnimFraction()
{
	float animFraction = 0.0f;
	if( IsDying() )
	{
		double animStart = m_animStartTime;
		double animFinish = animStart + PIPE_DEATH_SECONDS;
		animFraction = (float)( (g_timeNow - animStart) / (animFinish - animStart) );
		animFraction = ClampFloat( animFraction, 0.0f, 1.0f );
	}

	return animFraction;
}


