// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#pragma once
#include "Vector2.h"


enum SpawnType
{
	OBJTYPE_UNKNOWN = -1,
	OBJTYPE_GRUNT = 0,
	OBJTYPE_BULLETSMALL,
	NUM_OBJTYPES,
};


class Enemy
{
public:
	static std::list< Enemy* > enemyList;

	Vector2		m_pos;
	Vector2		m_vel;
	float		m_facingRadians;
	Vector2		m_forward;
	int			m_hitPoints;
//	SpawnType	m_type;

	Enemy();
	virtual ~Enemy();

	static UpdateEnemies();
	static DrawEnemies();
	virtual void Update() = 0;
	virtual void Draw() = 0;
};


class EnemyGrunt : public Enemy
{
public:
	static std::list< EnemyGrunt* > enemyGruntList;

	double m_timeLastShot;

	EnemyGrunt();
	EnemyGrunt( const Vector2& pos, const Vector2& vel );
	~EnemyGrunt();

	void Update();
	void Draw();
};


class EnemyBulletSmall : public Enemy
{
public:
	EnemyBulletSmall();
	EnemyBulletSmall( const Vector2& pos, const Vector2& vel );
	~EnemyBulletSmall();

	void Update();
	void Draw();
};


