// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#include "pch.h"
#include "GameBalance.h"


/// Base-related tweaks
const float		PIPE_LENGTH = 60.0f;
const Vector2	GRID_BASIS_WIDTH( PIPE_LENGTH, 0.0f );
const Vector2	GRID_BASIS_HEIGHT( 0.5f * PIPE_LENGTH, 0.86602540378443864676372317075294f * PIPE_LENGTH );
const float		NODE_RADIUS = 8.0f;
const float		JUNCTION_RADIUS = 7.0f;
const float		PIPE_RADIUS = 6.0f;
const int		TERMINATOR_HP = 1;
const int		HEART_HP = 1;
const double	PIPE_DEATH_SECONDS = 0.3;
const double	BASE_DEATH_SECONDS = 6.0;

/// Player-related tweaks
const float		PLAYER_MOVE_SPEED = 300.0f;
const float		PLAYER_BULLET_SPEED = 1200.0f;
const int		BULLETS_PER_SECOND = 25;
const double	LIFESPAN_PLAYER_BULLETS = 1.0;
const float		RADIUS_PLAYER_BULLETS = 5.0f;
const float		DAMAGE_PLAYER_BULLETS = 10.0f;

/// Enemy-related tweaks
const float		ENEMY_GRUNT_LAUNCHSPEED = 60.0f;
const float		ENEMY_GRUNT_ACCELERATION = 60.0f;
const float		ENEMY_GRUNT_PREFERRED_DISTANCE = 400.0f;
const float		ENEMY_BULLETSMALL_LAUNCHSPEED = 100.0f;
const float		ENEMY_GRUNT_BULLET_FIRE_INTERVAL = 1.9f;
const double	ENEMY_GRUNT_WEAPONS_ARM_TIME = 1.0;

/// Spawner-related tweaks
const double	SPAWNINTERVAL_DEFAULT = 3.0;
const int		SPAWNMAXCOUNT_DEFAULT = 10;

