// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#pragma once
#include "Vector2.h"


enum OctDirection
{
	/// Eight cardinal and semi-cardinal directions
	OCTDIRECTION_NONE = -1,
	OCTDIRECTION_EAST = 0,
	OCTDIRECTION_NORTHEAST,
	OCTDIRECTION_NORTH,
	OCTDIRECTION_NORTHWEST,
	OCTDIRECTION_WEST,
	OCTDIRECTION_SOUTHWEST,
	OCTDIRECTION_SOUTH,
	OCTDIRECTION_SOUTHEAST,
	NUM_OCTDIRECTIONS,
};


class Player
{
public:
	Vector2			m_pos;
	Vector2			m_vel;
	Vector2			m_forward;
	float			m_facingRadians;
	float			m_shipImageScale;
	OctDirection	m_direction;

	bool			m_isKeyDown_Up;
	bool			m_isKeyDown_Down;
	bool			m_isKeyDown_Left;
	bool			m_isKeyDown_Right;

	Vector2 GetNormalVectorForMoveDirection( OctDirection direction );

	Player();
	~Player();

	void Init();
	void Update();

	void DrawShip();
	void Draw();
};


//-------------------------------------------------------------------------------------------------
// Extern'd globals
//-------------------------------------------------------------------------------------------------
extern Player g_player;


