// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#pragma once
#include "Vector2.h"
#include "AABB2.h"


enum ProjectileType
{
	PROJECTILETYPE_PLAYER_BOLT,
	PROJECTILETYPE_NUM_TYPES
};




class Projectile
{
public:
	static const Projectile& SpawnProjectile( const Vector2& position, const Vector2& velocity, ProjectileType projectileType, float density );
	static void ExpireParticles();
	static void UpdateParticles();

	Vector2			m_pos;
	Vector2			m_vel;
	ProjectileType	m_type;
	double			m_birthDate;
	float			m_density;
	Vector2			m_moveVector;
	Vector2			m_endPos;
	AABB2			m_moveBounds;
	unsigned int	m_moveBoundsFreshnessFrameNumber;

	void UpdateMoveBounds();

	~Projectile();
	Projectile();
	Projectile( const Vector2& position, const Vector2& velocity, ProjectileType projectileType, float projectileDensity );
	Projectile( const Projectile& projectile );
};



extern float g_particleTypeRadiusTable[ PROJECTILETYPE_NUM_TYPES ];
extern float g_particleTypeDamageTable[ PROJECTILETYPE_NUM_TYPES ];
extern std::list<Projectile*> projectileList[ PROJECTILETYPE_NUM_TYPES ];
