// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#include "pch.h"
#include "Enemy.h"
#include "Player.h"
#include "gameCommon.h"
#include "GameBalance.h"
#include "Spawner.h"
#include "BaseCommon.h"



/*
//-------------------------------------------------------------------------------------------------
// Spawner
//-------------------------------------------------------------------------------------------------
Spawner::Spawner()
:
m_spawnType( ENEMYTYPE_UNKNOWN ),
m_spawnInterval( SPAWNINTERVAL_DEFAULT ),
m_maxSpawnCount( SPAWNMAXCOUNT_DEFAULT )
{
}
*/


//-------------------------------------------------------------------------------------------------
// Spawner
//-------------------------------------------------------------------------------------------------
Spawner::Spawner( SpawnType spawnType, double spawnInterval )
:
m_spawnType( spawnType ),
m_lastSpawnTime( 0.0 ),
m_spawnInterval( spawnInterval )
//m_maxSpawnCount( maxSpawnCount )
{
}


//-------------------------------------------------------------------------------------------------
// Update
//-------------------------------------------------------------------------------------------------
void Spawner::Update( const Vector2& pos, const Vector2& vel )
{
	/// Check if spawner is sufficiently offscreen
	if( IsDistanceBetweenPointsGreater( pos, g_player.m_pos, 640.0f ) )
		return;

	/// Determine if it's time yet to spawn another... whatever it is we spawn
	double timeNow = g_timeNow;
	double timeSinceLastSpawn = timeNow - m_lastSpawnTime;
	if( timeSinceLastSpawn < m_spawnInterval )
		return;

	/// Take special action (do nothing?) if max spawn count already met
	SpawnObjectFromPosVel( pos, vel );
	m_lastSpawnTime = timeNow;
}


//-------------------------------------------------------------------------------------------------
// SpawnObjectFromPosVel
//-------------------------------------------------------------------------------------------------
void Spawner::SpawnObjectFromPosVel( const Vector2& pos, const Vector2& vel )
{
	Enemy* spawn;

	switch( m_spawnType )
	{
		case OBJTYPE_GRUNT:
			spawn = new EnemyGrunt( pos, vel );
			break;
		case OBJTYPE_BULLETSMALL:
			spawn = new EnemyBulletSmall( pos, vel );
			break;
	}
}




